/**********************************************************************
 *
 * mgq.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: mgq.h 115 1999-01-19 01:38:20Z rjmcnab $
 *
 *********************************************************************/


#ifndef MGQ_H
#define MGQ_H

#ifdef __cplusplus
extern "C" {
#endif

enum result_kinds {
	result_docs,      /* Return the documents found in last search */
	result_docnums,   /* Return document id numbers and weights */
	result_termfreqs, /* Return terms and frequencies */
	result_terms      /* Return matching query terms */
    };

int mgq_ask(char *line);
int mgq_results(enum result_kinds kind,int skip, int howmany, int (*sender)(char *, int, int, float, void *), void *ptr);
int mgq_numdocs(void);
int mgq_numterms(void);


int is_dbcache_full (void);
int load_database (char *collection, char *mgdir, char *gensuffix, char *textsuffix);
int load_text_database (char *collection);
void close_all_databases (void);


#ifdef __cplusplus
}
#endif


#endif
