/**********************************************************************
 *
 * converter.cpp -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: converter.cpp 150 1999-02-05 10:42:50Z rjmcnab $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.1  1999/02/05 10:42:45  rjmcnab

   Continued working on receptionist

 */


#include "converter.h"



// the converters within converterinfo become the property of
// of this class after add_converter has been called. They should
// be allocated with new but not explicitly destroyed (they will
// be destroyed when this class is destroyed).
void convertinfoclass::add_converter (const text_t &name, inconvertclass *inconverter,
				      rzwsoutconvertclass *outconverter) {
  // can't add a null converter or an action with no name
  if (inconverter == NULL || outconverter == NULL || name.empty()) {
    if (inconverter != NULL) delete inconverter;
    if (outconverter != NULL) delete outconverter;
    return;
  }

  converterinfo info;
  info.name = name;
  info.inconverter = inconverter;
  info.outconverter = outconverter;
  converters[name] = info;
  info.inconverter = NULL;  // ownership has changed
  info.outconverter = NULL; // ownership has changed
}

// get_inconverter will return NULL if the convert could not be found
inconvertclass *convertinfoclass::get_inconverter (const text_t &name) {
  iterator here = converters.find (name);
  if (here == converters.end()) return NULL;

  return (*here).second.inconverter;
}

// get_outconverter will return NULL if the convert could not be found
rzwsoutconvertclass *convertinfoclass::get_outconverter (const text_t &name) {
  iterator here = converters.find (name);
  if (here == converters.end()) return NULL;

  return (*here).second.outconverter;
}

